'$INCLUDE: 'DIRECTQB.BI'

' NOTE: This does NOT use EMS.
' This is in conjunction with using 16 by 16 pixel sprites.
' We're going to run 512 NPCs!

'       The ONLY graphic routines used:
' DQBinitVGA = SCREEN 13
' DQBPrint = PRINT with more flexibility.
' DQBGet = GET with more flexibility.
' DQBfPUT = EXACTLY like QB's PUT but FASTER, no transparency or clipping.
' DQBPUT = PUT routine with transparency and clipping.
' DQBCopyLayer = PCOPY with flexibility and SCREEN 13 copying.

'       The ONLY misc routines used:
' DQBsetBaseLayer = Double Buffer better than DIM Buffer(32001)
' DQBinit = Enable DQB, so we don't crash!
' DQBinstallKeyboard = Toggling multiple key support.
' DQBkey(ASC code) = FUNCTION INKEY$, but with the ability to do more keys.
' DQBClose = Release everything

DECLARE SUB SetupThings ()       ' Set up sprites and loading stuff.
DECLARE SUB EndProgram ()        ' End this engine.
DECLARE SUB InputControl ()      ' Keyboard
DECLARE SUB Direct512NPCs ()     ' Moving 512 NPCs
DECLARE SUB Move512NPCs ()       ' Moving 512 NPCs
DECLARE SUB MakeMyStupidMap ()   ' Getting a random map
DECLARE SUB DrawLayer1 ()        ' Draw walls and tiles
DECLARE SUB DrawNPCs ()          ' Draw NPCs
DECLARE SUB DrawLayer2 ()        ' Draw ceilings
DECLARE SUB ScrollMath ()        ' Scroll Math

COMMON SHARED VirtX                        ' Scrolling X
COMMON SHARED VirtY                        ' Scrolling Y
COMMON SHARED CameraX                      ' Camera X
COMMON SHARED CameraY                      ' Camera Y
COMMON SHARED Frames                       ' Frame animation

DEFINT A-Z                                 ' INTEGERs for speed
RANDOMIZE TIMER                            ' Random generator toggled

DIM SHARED TileMap1(-1 TO 80, -1 TO 50)    ' Tile map floor
DIM SHARED TileMap2(-1 TO 80, -1 TO 50)    ' Tile map overlaying NPCs
DIM SHARED NPCE(0 TO 512)                  ' NPC exist?
DIM SHARED NPCX(0 TO 512)                  ' NPC X Coor
DIM SHARED NPCY(0 TO 512)                  ' NPC Y Coor
DIM SHARED NPCD(0 TO 512)                  ' NPC Direction
DIM SHARED NPCS(0 TO 512)                  ' NPC Steps
DIM SHARED HackMan(0 TO 129, 0 TO 15)      ' Hack-Man sprites
DIM SHARED Floor1(0 TO 129, 0 TO 3)        ' Floor sprite 1
DIM SHARED Floor2(0 TO 129, 0 TO 3)        ' Floor sprite 2
DIM SHARED LayOver1(0 TO 129, 0 TO 3)      ' Lay over sprite 1
DIM SHARED LayOver2(0 TO 129, 0 TO 3)      ' Lay over sprite 2
DIM SHARED Wall1(0 TO 129, 0 TO 3)         ' Wall sprite 1
DIM SHARED Wall2(0 TO 129, 0 TO 3)         ' Wall sprite 2

NPCE(0) = 1                ' Hack-Man you control.
NPCX(0) = 32
NPCY(0) = 32
NPCD(0) = 1

MakeMyStupidMap            ' Calling for a random map
SetupThings                ' Always needed

DO                                ' Beginning of my main loop
C = C + 1                         ' Frame counter
  IF B! < TIMER THEN              ' Need to update FPS?
  B! = TIMER + 1                  ' 1 second for next update
  FPS = C                         ' Frames per second
  C = 0                           ' Reset frame counter
  IF TIMER < 1 THEN B! = 0        ' Midnight bug. :P
  END IF                          ' End block
Frames = (Frames + 1) MOD 64      ' Frame animation.
InputControl                      ' Keyboard
Direct512NPCs                     ' Direct 512 NPCs
Move512NPCs                       ' Move 512 NPCs
ScrollMath                        ' This positions Camera and player
DrawLayer1                        ' Draw floors and walls
DrawNPCs                          ' Draw NPCs
DrawLayer2                        ' Draw ceilings
'WAIT &H3DA, 8: WAIT &H3DA, 8, 8  ' Flickerless graphics and universe delay.
DQBPrint B0, STR$(FPS), 6, 6, 0   ' Shadow for FPS
DQBPrint B0, STR$(FPS), 5, 5, 15  ' FPS display in white
DQBcopyLayer B0, 0                ' Copy buffer to screen.
LOOP UNTIL DQBkey(1)              ' ESC key to exit out of main loop.

EndProgram                 ' Always needed

REM $DYNAMIC
SUB Direct512NPCs

FOR A = 1 TO 512

IF NPCE(A) = 0 THEN 2            ' We don't want to work with dead NPCs. :P

DX = NPCX(A) \ 16                ' X Pointer
DY = NPCY(A) \ 16                ' Y Pointer
IF NPCS(A) > 0 THEN 2            ' Walking? NEXT!
CX = INT(RND * 8) + 1             ' Randomize their steps
IF CX < 2 THEN 2                  ' Should we move it?
CX = INT(RND * 8) + 1             ' Random direction

P1 = TileMap1(DX - 1, DY - 1)      ' Top Left pointer
P2 = TileMap1(DX + 1, DY - 1)      ' Top Right pointer
P3 = TileMap1(DX - 1, DY + 1)      ' Bottom Left pointer
P4 = TileMap1(DX + 1, DY + 1)      ' Bottom Right pointer
P5 = TileMap1(DX, DY - 1)          ' Top pointer
P6 = TileMap1(DX - 1, DY)          ' Left pointer
P7 = TileMap1(DX + 1, DY)          ' Right pointer
P8 = TileMap1(DX, DY + 1)          ' Bottom pointer

SELECT CASE CX                                           ' What direction?
CASE 1: IF P1 < 3 THEN NPCD(A) = 1: NPCS(A) = 16: GOTO 2
CASE 2: IF P2 < 3 THEN NPCD(A) = 2: NPCS(A) = 16: GOTO 2
CASE 3: IF P3 < 3 THEN NPCD(A) = 3: NPCS(A) = 16: GOTO 2
CASE 4: IF P4 < 3 THEN NPCD(A) = 4: NPCS(A) = 16: GOTO 2
CASE 5: IF P5 < 3 THEN NPCD(A) = 5: NPCS(A) = 16: GOTO 2
CASE 6: IF P6 < 3 THEN NPCD(A) = 6: NPCS(A) = 16: GOTO 2
CASE 7: IF P7 < 3 THEN NPCD(A) = 7: NPCS(A) = 16: GOTO 2
CASE 8: IF P8 < 3 THEN NPCD(A) = 8: NPCS(A) = 16: GOTO 2
END SELECT

2 NEXT

END SUB

SUB DrawLayer1

DX = CameraX \ 16      ' Tile Scrolling, hehe
DY = CameraY \ 16
MX = CameraX MOD 16    ' Pixel scrolling, hehe
MY = CameraY MOD 16
CF = Frames \ 16

FOR X = 0 TO 20
A = TileMap1(X + DX, DY)
SELECT CASE A                      ' Border edges for DQBPUT (Clipping)
CASE 1: DQBPut B0, X * 16 - MX, -MY, VARSEG(Floor1(0, CF)), VARPTR(Floor1(0, CF))
CASE 2: DQBPut B0, X * 16 - MX, -MY, VARSEG(Floor2(0, CF)), VARPTR(Floor2(0, CF))
CASE 3: DQBPut B0, X * 16 - MX, -MY, VARSEG(Wall1(0, CF)), VARPTR(Wall1(0, CF))
CASE 4: DQBPut B0, X * 16 - MX, -MY, VARSEG(Wall2(0, CF)), VARPTR(Wall2(0, CF))
END SELECT
A = TileMap1(X + DX, 12 + DY)
SELECT CASE A                      ' Border edges for DQBPUT (Clipping)
CASE 1: DQBPut B0, X * 16 - MX, -MY + (16 * 12), VARSEG(Floor1(0, CF)), VARPTR(Floor1(0, CF))
CASE 2: DQBPut B0, X * 16 - MX, -MY + (16 * 12), VARSEG(Floor2(0, CF)), VARPTR(Floor2(0, CF))
CASE 3: DQBPut B0, X * 16 - MX, -MY + (16 * 12), VARSEG(Wall1(0, CF)), VARPTR(Wall1(0, CF))
CASE 4: DQBPut B0, X * 16 - MX, -MY + (16 * 12), VARSEG(Wall2(0, CF)), VARPTR(Wall2(0, CF))
END SELECT
A = TileMap1(X + DX, 13 + DY)
SELECT CASE A                      ' Border edges for DQBPUT (Clipping)
CASE 1: DQBPut B0, X * 16 - MX, -MY + (16 * 13), VARSEG(Floor1(0, CF)), VARPTR(Floor1(0, CF))
CASE 2: DQBPut B0, X * 16 - MX, -MY + (16 * 13), VARSEG(Floor2(0, CF)), VARPTR(Floor2(0, CF))
CASE 3: DQBPut B0, X * 16 - MX, -MY + (16 * 13), VARSEG(Wall1(0, CF)), VARPTR(Wall1(0, CF))
CASE 4: DQBPut B0, X * 16 - MX, -MY + (16 * 13), VARSEG(Wall2(0, CF)), VARPTR(Wall2(0, CF))
END SELECT
NEXT

FOR Y = 0 TO 13
A = TileMap1(DX, DY + Y)
SELECT CASE A                      ' Border edges for DQBPUT (Clipping)
CASE 1: DQBPut B0, -MX, 16 * Y - MY, VARSEG(Floor1(0, CF)), VARPTR(Floor1(0, CF))
CASE 2: DQBPut B0, -MX, 16 * Y - MY, VARSEG(Floor2(0, CF)), VARPTR(Floor2(0, CF))
CASE 3: DQBPut B0, -MX, 16 * Y - MY, VARSEG(Wall1(0, CF)), VARPTR(Wall1(0, CF))
CASE 4: DQBPut B0, -MX, 16 * Y - MY, VARSEG(Wall2(0, CF)), VARPTR(Wall2(0, CF))
END SELECT

A = TileMap1(20 + DX, DY + Y)
SELECT CASE A                      ' Border edges for DQBPUT (Clipping)
CASE 1: DQBPut B0, -MX + (20 * 16), 16 * Y - MY, VARSEG(Floor1(0, CF)), VARPTR(Floor1(0, CF))
CASE 2: DQBPut B0, -MX + (20 * 16), 16 * Y - MY, VARSEG(Floor2(0, CF)), VARPTR(Floor2(0, CF))
CASE 3: DQBPut B0, -MX + (20 * 16), 16 * Y - MY, VARSEG(Wall1(0, CF)), VARPTR(Wall1(0, CF))
CASE 4: DQBPut B0, -MX + (20 * 16), 16 * Y - MY, VARSEG(Wall2(0, CF)), VARPTR(Wall2(0, CF))
END SELECT
NEXT

FOR Y = 1 TO 11
FOR X = 1 TO 19
A = TileMap1(X + DX, Y + DY)
SELECT CASE A                      ' Border edges for DQBPUT (Clipping)
CASE 1: DQBfPut B0, X * 16 - MX, Y * 16 - MY, VARSEG(Floor1(0, CF)), VARPTR(Floor1(0, CF))
CASE 2: DQBfPut B0, X * 16 - MX, Y * 16 - MY, VARSEG(Floor2(0, CF)), VARPTR(Floor2(0, CF))
CASE 3: DQBfPut B0, X * 16 - MX, Y * 16 - MY, VARSEG(Wall1(0, CF)), VARPTR(Wall1(0, CF))
CASE 4: DQBfPut B0, X * 16 - MX, Y * 16 - MY, VARSEG(Wall2(0, CF)), VARPTR(Wall2(0, CF))
END SELECT
NEXT
NEXT

END SUB

REM $STATIC
SUB DrawLayer2

DX = CameraX \ 16      ' Tile Scrolling, hehe
DY = CameraY \ 16
MX = CameraX MOD 16    ' Pixel scrolling, hehe
MY = CameraY MOD 16
CF = Frames \ 16

FOR Y = 0 TO 13
FOR X = 0 TO 20
A = TileMap2(X + DX, Y + DY)
SELECT CASE A
CASE 1: DQBPut B0, X * 16 - MX, Y * 16 - MY, VARSEG(LayOver1(0, CF)), VARPTR(LayOver1(0, CF))
CASE 2: DQBPut B0, X * 16 - MX, Y * 16 - MY, VARSEG(LayOver2(0, CF)), VARPTR(LayOver2(0, CF))
END SELECT
NEXT
NEXT

END SUB

SUB DrawNPCs

SELECT CASE NPCD(0)
CASE 1, 3, 6
        SELECT CASE NPCS(0)
        CASE 0, 1, 15, 16: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 8))
        CASE 2, 3, 13, 14: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 9))
        CASE 4, 5, 11, 12: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 10))
        CASE 6, 7, 8, 9, 10: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 11))
        END SELECT
CASE 2, 4, 7
        SELECT CASE NPCS(0)
        CASE 0, 1, 15, 16: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 0))
        CASE 2, 3, 13, 14: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 1))
        CASE 4, 5, 11, 12: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 2))
        CASE 6, 7, 8, 9, 10: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 3))
        END SELECT
CASE 5
        SELECT CASE NPCS(A)
        CASE 0, 1, 15, 16: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 12)), VARPTR(HackMan(0, 12))
        CASE 2, 3, 13, 14: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 13)), VARPTR(HackMan(0, 13))
        CASE 4, 5, 11, 12: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 14)), VARPTR(HackMan(0, 14))
        CASE 6, 7, 8, 9, 10: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 15)), VARPTR(HackMan(0, 15))
        END SELECT
CASE 8
        SELECT CASE NPCS(A)
        CASE 0, 1, 15, 16: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 4)), VARPTR(HackMan(0, 4))
        CASE 2, 3, 13, 14: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 5)), VARPTR(HackMan(0, 5))
        CASE 4, 5, 11, 12: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 6)), VARPTR(HackMan(0, 6))
        CASE 6, 7, 8, 9, 10: DQBPut B0, NPCX(0), NPCY(0), VARSEG(HackMan(0, 7)), VARPTR(HackMan(0, 7))
        END SELECT
END SELECT



' Draw hundreads of Hack-Mans!

FOR A = 1 TO 512
IF NPCE(A) = 0 THEN 5
CV = 0
IF NPCX(A) - CameraX < -15 THEN CV = 1
IF NPCX(A) - CameraX > 319 THEN CV = 1
IF NPCY(A) - CameraY < -15 THEN CV = 1
IF NPCY(A) - CameraY > 199 THEN CV = 1
IF CV = 1 THEN 5
SELECT CASE NPCD(A)
CASE 1, 3, 6
        SELECT CASE NPCS(A)
        CASE 0, 1, 15, 16: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 8))
        CASE 2, 3, 13, 14: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 9))
        CASE 4, 5, 11, 12: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 10))
        CASE 6, 7, 8, 9, 10: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 11))
        END SELECT
CASE 2, 4, 7
        SELECT CASE NPCS(A)
        CASE 0, 1, 15, 16: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 0))
        CASE 2, 3, 13, 14: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 1))
        CASE 4, 5, 11, 12: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 2))
        CASE 6, 7, 8, 9, 10: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 9)), VARPTR(HackMan(0, 3))
        END SELECT
CASE 5
        SELECT CASE NPCS(A)
        CASE 0, 1, 15, 16: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 12)), VARPTR(HackMan(0, 12))
        CASE 2, 3, 13, 14: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 13)), VARPTR(HackMan(0, 13))
        CASE 4, 5, 11, 12: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 14)), VARPTR(HackMan(0, 14))
        CASE 6, 7, 8, 9, 10: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 15)), VARPTR(HackMan(0, 15))
        END SELECT
CASE 8
        SELECT CASE NPCS(A)
        CASE 0, 1, 15, 16: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 4)), VARPTR(HackMan(0, 4))
        CASE 2, 3, 13, 14: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 5)), VARPTR(HackMan(0, 5))
        CASE 4, 5, 11, 12: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 6)), VARPTR(HackMan(0, 6))
        CASE 6, 7, 8, 9, 10: DQBPut B0, NPCX(A) - CameraX, NPCY(A) - CameraY, VARSEG(HackMan(0, 7)), VARPTR(HackMan(0, 7))
        END SELECT
END SELECT
5 NEXT

END SUB

REM $DYNAMIC
SUB EndProgram

DQBClose            ' Close down everything from DQB
Q& = SETMEM(80000)  ' Return QB's memory
SCREEN 0            ' Set to 640 * 480 * 16 colors
WIDTH 80, 25        ' Default it to normal.
COLOR 10            ' Green

PRINT
PRINT "  Created by James Robert Osborne."
PRINT
PRINT " ICQ UIN = 46021495"
PRINT " Website = http://wisdomdude.cjb.net"
PRINT " Email = WisdomDude@CyberDude.com"
PRINT

DO: LOOP UNTIL LEN(INKEY$)   ' Wait for keypresses
END                          ' End program

END SUB

SUB InputControl

IF DQBkey(72) THEN D1 = 1                 ' Pointer for UP key
IF DQBkey(75) THEN D2 = 1                 ' Pointer for LEFT key
IF DQBkey(77) THEN D3 = 1                 ' Pointer for RIGHT key
IF DQBkey(80) THEN D4 = 1                 ' Pointer for DOWN key

IF D1 > 0 AND D4 > 0 THEN D1 = 0: D4 = 0  ' Get rid of opposing keys (U, D)
IF D2 > 0 AND D3 > 0 THEN D2 = 0: D3 = 0  ' Get rid of opposing keys (L, R)

CX = D1 + D2 + D3 + D4
IF CX = 0 THEN EXIT SUB        ' No keys being pressed? leave. :P
IF NPCS(0) > 0 THEN EXIT SUB   ' If player is still walking, then leave.

DX = VirtX \ 16   ' Pointers
DY = VirtY \ 16   ' Pointers

P1 = TileMap1(DX - 1, DY - 1)      ' Top Left pointer
P2 = TileMap1(DX + 1, DY - 1)      ' Top Right pointer
P3 = TileMap1(DX - 1, DY + 1)      ' Bottom Left pointer
P4 = TileMap1(DX + 1, DY + 1)      ' Bottom Right pointer
P5 = TileMap1(DX, DY - 1)          ' Top pointer
P6 = TileMap1(DX - 1, DY)          ' Left pointer
P7 = TileMap1(DX + 1, DY)          ' Right pointer
P8 = TileMap1(DX, DY + 1)          ' Bottom pointer

IF D1 = 1 AND D2 = 1 AND P1 < 3 THEN NPCD(0) = 1: NPCS(0) = 16: GOTO 1  ' NW
IF D1 = 1 AND D3 = 1 AND P2 < 3 THEN NPCD(0) = 2: NPCS(0) = 16: GOTO 1  ' NE
IF D4 = 1 AND D2 = 1 AND P3 < 3 THEN NPCD(0) = 3: NPCS(0) = 16: GOTO 1  ' SW
IF D4 = 1 AND D3 = 1 AND P4 < 3 THEN NPCD(0) = 4: NPCS(0) = 16: GOTO 1  ' SE
IF D1 = 1 AND P5 < 3 THEN NPCD(0) = 5: NPCS(0) = 16: GOTO 1             ' N
IF D2 = 1 AND P6 < 3 THEN NPCD(0) = 6: NPCS(0) = 16: GOTO 1             ' W
IF D3 = 1 AND P7 < 3 THEN NPCD(0) = 7: NPCS(0) = 16: GOTO 1             ' E
IF D4 = 1 AND P8 < 3 THEN NPCD(0) = 8: NPCS(0) = 16: GOTO 1             ' S

1

END SUB

SUB MakeMyStupidMap

' make horizontal border
FOR X = -1 TO 80
TileMap1(X, -1) = 3
TileMap1(X, 50) = 3
NEXT

' make vertical border
FOR Y = -1 TO 50
TileMap1(-1, Y) = 3
TileMap1(80, Y) = 3
NEXT

' Randomize walls floors and colored ceilings
FOR Y = 0 TO 49
FOR X = 0 TO 79
TileMap1(X, Y) = 1
CV = INT(RND * 3): IF CV = 2 THEN TileMap1(X, Y) = INT(RND * 4) + 1
CV = INT(RND * 2) + 1: IF CV = 1 THEN TileMap2(X, Y) = INT(RND * 3)
NEXT
NEXT

' Place NPCs everywhere!
FOR E = 1 TO 3              ' Recheck, hehe
FOR A = 1 TO 512
X = INT(RND * 70) + 5
Y = INT(RND * 40) + 5
IF TileMap1(X, Y) < 3 AND NPCE(A) = 0 THEN
NPCE(A) = 1
NPCX(A) = X * 16
NPCY(A) = Y * 16
END IF
NEXT
NEXT

END SUB

SUB Move512NPCs
                                ' The user
IF NPCS(0) = 0 THEN 3
SELECT CASE NPCD(0)
CASE 1: VirtX = VirtX - 1: VirtY = VirtY - 1: NPCS(0) = NPCS(0) - 1
CASE 2: VirtX = VirtX + 1: VirtY = VirtY - 1: NPCS(0) = NPCS(0) - 1
CASE 3: VirtX = VirtX - 1: VirtY = VirtY + 1: NPCS(0) = NPCS(0) - 1
CASE 4: VirtX = VirtX + 1: VirtY = VirtY + 1: NPCS(0) = NPCS(0) - 1
CASE 5: VirtY = VirtY - 1: NPCS(0) = NPCS(0) - 1
CASE 6: VirtX = VirtX - 1: NPCS(0) = NPCS(0) - 1
CASE 7: VirtX = VirtX + 1: NPCS(0) = NPCS(0) - 1
CASE 8: VirtY = VirtY + 1: NPCS(0) = NPCS(0) - 1
END SELECT
3

FOR A = 1 TO 512                ' Other 512
IF NPCS(A) = 0 THEN 4
SELECT CASE NPCD(A)
CASE 1: NPCX(A) = NPCX(A) - 1: NPCY(A) = NPCY(A) - 1: NPCS(A) = NPCS(A) - 1
CASE 2: NPCX(A) = NPCX(A) + 1: NPCY(A) = NPCY(A) - 1: NPCS(A) = NPCS(A) - 1
CASE 3: NPCX(A) = NPCX(A) - 1: NPCY(A) = NPCY(A) + 1: NPCS(A) = NPCS(A) - 1
CASE 4: NPCX(A) = NPCX(A) + 1: NPCY(A) = NPCY(A) + 1: NPCS(A) = NPCS(A) - 1
CASE 5: NPCY(A) = NPCY(A) - 1: NPCS(A) = NPCS(A) - 1
CASE 6: NPCX(A) = NPCX(A) - 1: NPCS(A) = NPCS(A) - 1
CASE 7: NPCX(A) = NPCX(A) + 1: NPCS(A) = NPCS(A) - 1
CASE 8: NPCY(A) = NPCY(A) + 1: NPCS(A) = NPCS(A) - 1
END SELECT
4 NEXT

END SUB

SUB ScrollMath

MaxX% = 16 * 79    ' Number of tiles in my map X
MaxY% = 16 * 49    ' Number of tiles in my map Y

IF VirtX > MaxX% THEN VirtX = MaxX%
IF VirtX < 0 THEN VirtX = 0
IF VirtY > MaxY% THEN VirtY = MaxY%
IF VirtY < 0 THEN VirtY = 0

' Basically, this is how I do camera and player positioning.

B% = 0
IF VirtX < 152 THEN B% = 1
IF VirtX > MaxX% - 152 THEN B% = 2
IF B% = 0 THEN NPCX(0) = 152: CameraX = VirtX - 152
IF B% = 1 THEN NPCX(0) = VirtX: CameraX = 0
IF B% = 2 THEN NPCX(0) = 320 - ABS(MaxX% - VirtX) - 16: CameraX = (MaxX% - 320) + 16
B% = 0
IF VirtY < 88 THEN B% = 1
IF VirtY > MaxY% - 88 THEN B% = 2
IF B% = 0 THEN NPCY(0) = 88: CameraY = VirtY - 88
IF B% = 1 THEN NPCY(0) = VirtY: CameraY = 0
IF B% = 2 THEN NPCY(0) = 192 - ABS(MaxY% - VirtY) - 16: CameraY = (MaxY% - 192) + 16

END SUB

SUB SetupThings

Q& = SETMEM(-80000)           ' Get memory from far heap for buffer

IF DQBinit(0, 0, 0) THEN DQBClose: PRINT "Something went wrong.": END

IF DQBsetBaseLayer(B0) = 0 THEN   ' DIM Buffer(32001) but better.
PRINT "Not enough base memory"
END
END IF

DQBinitVGA                              ' Set to 320 * 200 * 256 colors.

OPEN "JROENG.PAL" FOR BINARY AS #1      ' Open my palette
FOR A = 0 TO 255                        ' Get all 256 colors.

R$ = " ": G$ = " ": B$ = " "           ' Allowing me to GET one byte

GET #1, A * 3 + 1, R$                  ' Retrieving red value
GET #1, A * 3 + 2, G$                  ' Retrieving green value
GET #1, A * 3 + 3, B$                  ' Retrieving blue value

OUT &H3C8, A                      ' Palette port writing
OUT &H3C9, ASC(R$)                ' Write red value
OUT &H3C9, ASC(G$)                ' Write green value
OUT &H3C9, ASC(B$)                ' Write blue value
NEXT

DEF SEG = &HA000                  ' Video Segment for SCREEN 13
BLOAD "JROENG.BSV"                ' My image file. Load ALL those pixels.
DEF SEG                           ' Reset segment to default by omitting

                                  ' Grab ALL Hack-Man's sprites.
FOR Y = 0 TO 3
FOR X = 0 TO 3
DQBGet 0, X * 16, Y * 16, X * 16 + 15, Y * 16 + 15, VARSEG(HackMan(0, Y * 4 + X)), VARPTR(HackMan(0, Y * 4 + X))
NEXT
NEXT
                                  ' And grab the rest for this short demo.
FOR X = 0 TO 3
DQBGet 0, 64 + (X * 16), 0, 79 + (X * 16), 15, VARSEG(Floor1(0, X)), VARPTR(Floor1(0, X))
DQBGet 0, 64 + (X * 16), 16, 79 + (X * 16), 31, VARSEG(Floor2(0, X)), VARPTR(Floor2(0, X))
DQBGet 0, 128 + (X * 16), 0, 143 + (X * 16), 15, VARSEG(Wall1(0, X)), VARPTR(Wall1(0, X))
DQBGet 0, 128 + (X * 16), 16, 143 + (X * 16), 31, VARSEG(Wall2(0, X)), VARPTR(Wall2(0, X))
DQBGet 0, 64 + (X * 16), 32, 79 + (X * 16), 47, VARSEG(LayOver1(0, X)), VARPTR(LayOver1(0, X))
DQBGet 0, 64 + (X * 16), 48, 79 + (X * 16), 63, VARSEG(LayOver2(0, X)), VARPTR(LayOver2(0, X))
NEXT

DO: LOOP UNTIL LEN(INKEY$)        ' Wait for pressed keys to continue.
DQBinstallKeyboard                ' DQB's Keyboard handler toggled

END SUB

